'use strict';

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _index;

function _load_index() {
  return _index = require('./api/consumer/index');
}

var _index2;

function _load_index2() {
  return _index2 = require('./api/scope/index');
}

var _extension;

function _load_extension() {
  return _extension = _interopRequireDefault(require('./extensions/extension'));
}

var _hooks;

function _load_hooks() {
  return _hooks = _interopRequireDefault(require('./hooks'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(_hooks || _load_hooks()).default.init();

module.exports = {
  show: function show(scopePath, id, opts) {
    return (0, (_index || _load_index()).getScopeComponent)({ scopePath, id, allVersions: opts && opts.versions }).then(function (c) {
      if (Array.isArray(c)) {
        return c.map(function (v) {
          return v.toObject();
        });
      }
      return c.toObject();
    });
  },
  list: function list(scopePath) {
    return (0, (_index2 || _load_index2()).scopeList)(scopePath).then(function (listScopeResult) {
      return listScopeResult.map(function (result) {
        return result.id.toString();
      });
    });
  },
  addMany: function () {
    var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(components, alternateCwd) {
      return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt('return', (0, (_index || _load_index()).addMany)(components, alternateCwd));

            case 1:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function addMany(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }(),
  /**
   * Load extension programmatically
   */
  loadExtension: function () {
    var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(args) {
      var extension;
      return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (_extension || _load_extension()).default.load(args);

            case 2:
              extension = _context2.sent;
              return _context2.abrupt('return', Promise.resolve(extension));

            case 4:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function loadExtension(_x3) {
      return _ref2.apply(this, arguments);
    };
  }()
};