'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _nothingToCompareTo;

function _load_nothingToCompareTo() {
  return _nothingToCompareTo = _interopRequireDefault(require('./exceptions/nothing-to-compare-to'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref2) {
    var id = _ref2.id,
        compare = _ref2.compare,
        allVersions = _ref2.allVersions,
        showRemoteVersions = _ref2.showRemoteVersions;
    var consumer, bitId, component;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context.sent;
            bitId = consumer.getParsedId(id);

            if (!allVersions) {
              _context.next = 6;
              break;
            }

            return _context.abrupt('return', consumer.loadAllVersionsOfComponentFromModel(bitId));

          case 6:
            _context.next = 8;
            return consumer.loadComponent(bitId);

          case 8:
            component = _context.sent;

            if (!showRemoteVersions) {
              _context.next = 12;
              break;
            }

            _context.next = 12;
            return consumer.addRemoteAndLocalVersionsToDependencies(component, true);

          case 12:
            if (!compare) {
              _context.next = 16;
              break;
            }

            if (component.componentFromModel) {
              _context.next = 15;
              break;
            }

            throw new (_nothingToCompareTo || _load_nothingToCompareTo()).default(id);

          case 15:
            return _context.abrupt('return', { component, componentModel: component.componentFromModel });

          case 16:
            _context.next = 18;
            return consumer.onDestroy();

          case 18:
            return _context.abrupt('return', { component });

          case 19:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function getConsumerBit(_x) {
    return _ref.apply(this, arguments);
  }

  return getConsumerBit;
}();