'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _hooks;

function _load_hooks() {
  return _hooks = _interopRequireDefault(require('../../../hooks'));
}

var _scopeComponentsImporter;

function _load_scopeComponentsImporter() {
  return _scopeComponentsImporter = _interopRequireDefault(require('../../../scope/component-ops/scope-components-importer'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HooksManagerInstance = (_hooks || _load_hooks()).default.getInstance();
// import logger from '../../../logger/logger';

exports.default = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(path, ids) {
    var noDependencies = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var headers = arguments[3];
    var bitIds, args, scope, scopeComponentsImporter, importedComponents, clientVersion, componentObjects;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            bitIds = (_bitId || _load_bitId()).BitIds.deserialize(ids);
            args = { path, bitIds, noDependencies };
            // This might be undefined in case of fork process like during bit test command

            if (HooksManagerInstance) {
              HooksManagerInstance.triggerHook((_constants || _load_constants()).PRE_SEND_OBJECTS, args, headers);
            }
            _context.next = 5;
            return (0, (_scope || _load_scope()).loadScope)(path);

          case 5:
            scope = _context.sent;
            scopeComponentsImporter = (_scopeComponentsImporter || _load_scopeComponentsImporter()).default.getInstance(scope);

            if (!noDependencies) {
              _context.next = 13;
              break;
            }

            _context.next = 10;
            return scopeComponentsImporter.importManyWithoutDependencies(bitIds, false);

          case 10:
            _context.t0 = _context.sent;
            _context.next = 16;
            break;

          case 13:
            _context.next = 15;
            return scopeComponentsImporter.importMany(bitIds);

          case 15:
            _context.t0 = _context.sent;

          case 16:
            importedComponents = _context.t0;
            clientVersion = headers ? headers.version : null;
            _context.next = 20;
            return scopeComponentsImporter.componentsToComponentsObjects(
            // $FlowFixMe
            importedComponents, clientVersion);

          case 20:
            componentObjects = _context.sent;

            if (!HooksManagerInstance) {
              _context.next = 24;
              break;
            }

            _context.next = 24;
            return HooksManagerInstance.triggerHook((_constants || _load_constants()).POST_SEND_OBJECTS, {
              componentObjects,
              scopePath: path,
              componentsIds: bitIds.serialize(),
              scopeName: scope.scopeJson.name
            }, headers);

          case 24:
            return _context.abrupt('return', componentObjects);

          case 25:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function fetch(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return fetch;
}();