'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../../../error/general-error'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var validForkLevels = (_ramda || _load_ramda()).default.values((_constants || _load_constants()).TESTS_FORK_LEVEL);

var verboseReport = false;

var Test = function (_Command) {
  _inherits(Test, _Command);

  function Test() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Test);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Test.__proto__ || Object.getPrototypeOf(Test)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'test [id]', _this.description = `test any set of components with a configured tester as defined in bit.json (by default applies only on modified components)\n  https://${(_constants || _load_constants()).BASE_DOCS_DOMAIN}/docs/testing-components.html)`, _this.alias = '', _this.opts = [['a', 'all', 'test all components in your workspace, including unmodified components'], ['v', 'verbose', 'showing npm verbose output for inspection and prints stack trace'], ['', 'fork-level <forkLevel>', 'NONE / ONE / COMPONENT how many child process create for test running']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Test, [{
    key: 'action',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref3, _ref4) {
        var _ref5 = _slicedToArray(_ref3, 1),
            id = _ref5[0];

        var all = _ref4.all,
            verbose = _ref4.verbose,
            forkLevel = _ref4.forkLevel;
        var testRes, pass, res;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(id && all)) {
                  _context.next = 2;
                  break;
                }

                throw new (_generalError || _load_generalError()).default('use "--all" to test all components or use a component ID to test a specific component. run tests to all new and modified components by removing all flags and parameters');

              case 2:
                if (!(forkLevel && !validForkLevels.includes(forkLevel))) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt('return', Promise.reject(new (_generalError || _load_generalError()).default(`fork level must be one of: ${validForkLevels.join()}`)));

              case 4:
                verboseReport = verbose || false;
                _context.next = 7;
                return (0, (_consumer || _load_consumer()).test)(id, forkLevel, all, verbose);

              case 7:
                testRes = _context.sent;
                pass = testRes.every(function (comp) {
                  return comp.pass;
                });
                res = {
                  data: testRes,
                  __code: pass ? 0 : 1
                };
                return _context.abrupt('return', res);

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function action(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return action;
    }()
  }, {
    key: 'report',
    value: function report(results) {
      if (Array.isArray(results)) return (0, (_chalkBox || _load_chalkBox()).paintAllSpecsResults)(results, verboseReport) + (0, (_chalkBox || _load_chalkBox()).paintSummarySpecsResults)(results);
      return "couldn't get test results...";
    }
  }]);

  return Test;
}((_command || _load_command()).default);

exports.default = Test;