'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = newerVersionTemplate;


var helpPhrase = 'use checkout to merge latest versions with current changes. you can also tag current changes as a newer version with the --ignore-newest-version flag';
function newerVersionTemplate(newerVersions) {
  function formatOne(newerVersion) {
    return `unable to tag ${newerVersion.componentId}
current version ${newerVersion.currentVersion} is older than the latest ${newerVersion.latestVersion}.`;
  }

  var result = `${newerVersions.map(formatOne).join('\n')}\n${helpPhrase}`;
  return result;
}