'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _buildIfNeeded = function () {
  var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(_ref4) {
    var component = _ref4.component,
        consumer = _ref4.consumer,
        componentMap = _ref4.componentMap,
        scope = _ref4.scope,
        verbose = _ref4.verbose,
        directory = _ref4.directory,
        keep = _ref4.keep;
    var compiler, isolatedEnvironment, isolateOpts, componentWithDependencies, isolatedComponent, result;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            compiler = component.compiler;

            if (compiler) {
              _context2.next = 3;
              break;
            }

            throw new (_generalError || _load_generalError()).default('compiler was not found, nothing to build');

          case 3:
            if (!(!compiler.action && !compiler.oldAction)) {
              _context2.next = 5;
              break;
            }

            throw new (_invalidCompilerInterface || _load_invalidCompilerInterface()).default(compiler.name);

          case 5:
            if (!consumer) {
              _context2.next = 7;
              break;
            }

            return _context2.abrupt('return', _runBuild({ component, componentRoot: consumer.getPath(), consumer, componentMap, verbose }));

          case 7:
            if (!component.isolatedEnvironment) {
              _context2.next = 9;
              break;
            }

            return _context2.abrupt('return', _runBuild({ component, componentRoot: component.writtenPath, consumer, componentMap, verbose }));

          case 9:
            isolatedEnvironment = new (_environment || _load_environment()).default(scope, directory);
            _context2.prev = 10;
            _context2.next = 13;
            return isolatedEnvironment.create();

          case 13:
            isolateOpts = {
              verbose,
              installPackages: true,
              noPackageJson: false
            };
            _context2.next = 16;
            return isolatedEnvironment.isolateComponent(component.id, isolateOpts);

          case 16:
            componentWithDependencies = _context2.sent;
            isolatedComponent = componentWithDependencies.component;
            _context2.next = 20;
            return _runBuild({
              component,
              componentRoot: isolatedComponent.writtenPath,
              consumer,
              componentMap,
              verbose
            });

          case 20:
            result = _context2.sent;

            if (keep) {
              _context2.next = 24;
              break;
            }

            _context2.next = 24;
            return isolatedEnvironment.destroy();

          case 24:
            return _context2.abrupt('return', result);

          case 27:
            _context2.prev = 27;
            _context2.t0 = _context2['catch'](10);
            _context2.next = 31;
            return isolatedEnvironment.destroy();

          case 31:
            throw _context2.t0;

          case 32:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[10, 27]]);
  }));

  return function _buildIfNeeded(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

// Ideally it's better to use the dists from the model.
// If there is no consumer, it comes from the scope or isolated environment, which the dists are already saved.
// If there is consumer, check whether the component was modified. If it wasn't, no need to re-build.


var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _vinyl;

function _load_vinyl() {
  return _vinyl = _interopRequireDefault(require('vinyl'));
}

var _dists;

function _load_dists() {
  return _dists = _interopRequireDefault(require('../component/sources/dists'));
}

var _invalidCompilerInterface;

function _load_invalidCompilerInterface() {
  return _invalidCompilerInterface = _interopRequireDefault(require('../component/exceptions/invalid-compiler-interface'));
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../../environment'));
}

var _componentMap;

function _load_componentMap() {
  return _componentMap = _interopRequireDefault(require('../bit-map/component-map'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _externalBuildErrors;

function _load_externalBuildErrors() {
  return _externalBuildErrors = _interopRequireDefault(require('../component/exceptions/external-build-errors'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../../error/general-error'));
}

var _sources;

function _load_sources() {
  return _sources = require('../component/sources');
}

var _ejectConf;

function _load_ejectConf() {
  return _ejectConf = require('./eject-conf');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref2) {
    var component = _ref2.component,
        scope = _ref2.scope,
        save = _ref2.save,
        consumer = _ref2.consumer,
        noCache = _ref2.noCache,
        verbose = _ref2.verbose,
        keep = _ref2.keep;
    var bitMap, consumerPath, componentMap, componentDir, needToRebuild, builtFiles;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (_logger || _load_logger()).default.debug(`consumer-component.build ${component.id.toString()}`);
            // @TODO - write SourceMap Type

            if (component.compiler) {
              _context.next = 8;
              break;
            }

            if (!(!consumer || consumer.shouldDistsBeInsideTheComponent())) {
              _context.next = 5;
              break;
            }

            (_logger || _load_logger()).default.debug('compiler was not found, nothing to build');
            return _context.abrupt('return', null);

          case 5:
            (_logger || _load_logger()).default.debugAndAddBreadCrumb('build-component.buildComponent', 'compiler was not found, however, because the dists are set to be outside the components directory, save the source file as dists');
            component.copyFilesIntoDists();
            return _context.abrupt('return', component.dists);

          case 8:
            bitMap = consumer ? consumer.bitMap : undefined;
            consumerPath = consumer ? consumer.getPath() : '';
            componentMap = bitMap && bitMap.getComponentIfExist(component.id);
            componentDir = consumerPath;

            if (componentMap) {
              componentDir = consumerPath && componentMap.rootDir ? (_path || _load_path()).default.join(consumerPath, componentMap.rootDir) : undefined;
            }
            _context.next = 15;
            return _isNeededToReBuild(consumer, component.id, noCache);

          case 15:
            needToRebuild = _context.sent;

            if (!(!needToRebuild && !component.dists.isEmpty())) {
              _context.next = 19;
              break;
            }

            (_logger || _load_logger()).default.debugAndAddBreadCrumb('build-component.buildComponent', 'skip the build process as the component was not modified, use the dists saved in the model');
            return _context.abrupt('return', component.dists);

          case 19:
            (_logger || _load_logger()).default.debug('compiler found, start building');

            if (!(component.compiler && !component.compiler.loaded)) {
              _context.next = 23;
              break;
            }

            _context.next = 23;
            return component.compiler.install(scope, { verbose: !!verbose }, { workspaceDir: consumerPath, componentDir, dependentId: component.id });

          case 23:
            _context.next = 25;
            return _buildIfNeeded({
              component,
              consumer,
              componentMap,
              scope,
              keep,
              verbose: !!verbose
            });

          case 25:
            _context.t0 = _context.sent;

            if (_context.t0) {
              _context.next = 28;
              break;
            }

            _context.t0 = [];

          case 28:
            builtFiles = _context.t0;

            // return buildFilesP.then((buildedFiles) => {
            builtFiles.forEach(function (file) {
              if (file && (!file.contents || !(0, (_utils || _load_utils()).isString)(file.contents.toString()))) {
                throw new (_generalError || _load_generalError()).default('builder interface has to return object with a code attribute that contains string');
              }
            });
            component.setDists(builtFiles.map(function (file) {
              return new (_sources || _load_sources()).Dist(file);
            }));

            if (!save) {
              _context.next = 34;
              break;
            }

            _context.next = 34;
            return scope.sources.updateDist({ source: component });

          case 34:
            return _context.abrupt('return', component.dists);

          case 35:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function buildComponent(_x) {
    return _ref.apply(this, arguments);
  }

  return buildComponent;
}();

var _isNeededToReBuild = function () {
  var _ref5 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(consumer, componentId, noCache) {
    var componentStatus;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!noCache) {
              _context3.next = 2;
              break;
            }

            return _context3.abrupt('return', true);

          case 2:
            if (consumer) {
              _context3.next = 4;
              break;
            }

            return _context3.abrupt('return', false);

          case 4:
            _context3.next = 6;
            return consumer.getComponentStatusById(componentId);

          case 6:
            componentStatus = _context3.sent;
            return _context3.abrupt('return', componentStatus.modified);

          case 8:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function _isNeededToReBuild(_x3, _x4, _x5) {
    return _ref5.apply(this, arguments);
  };
}();

var _runBuild = function () {
  var _ref6 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(_ref7) {
    var component = _ref7.component,
        componentRoot = _ref7.componentRoot,
        consumer = _ref7.consumer,
        componentMap = _ref7.componentMap,
        verbose = _ref7.verbose;
    var compiler, rootDistDir, consumerPath, files, tmpFolderFullPath, componentDir, rootDistDirRelative;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            compiler = component.compiler;

            if (compiler) {
              _context5.next = 3;
              break;
            }

            throw new (_generalError || _load_generalError()).default('compiler was not found, nothing to build');

          case 3:
            rootDistDir = (_path || _load_path()).default.join(componentRoot, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME);
            consumerPath = consumer ? consumer.getPath() : '';
            files = component.files.map(function (file) {
              return file.clone();
            });
            tmpFolderFullPath = void 0;
            componentDir = '';

            if (componentMap) {
              rootDistDirRelative = component.dists.getDistDir(consumer, componentMap.getRootDir());

              if (consumer) rootDistDir = consumer.toAbsolutePath(rootDistDirRelative);
              if (consumerPath && componentMap.getComponentDir()) {
                componentDir = componentMap.getComponentDir() || '';
              }
            }
            return _context5.abrupt('return', Promise.resolve().then((0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4() {
              var context, isCompilerDetached, shouldWriteConfig, actionParams, result;
              return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
                while (1) {
                  switch (_context4.prev = _context4.next) {
                    case 0:
                      if (!(!compiler.action && !compiler.oldAction)) {
                        _context4.next = 2;
                        break;
                      }

                      throw new (_invalidCompilerInterface || _load_invalidCompilerInterface()).default(compiler.name);

                    case 2:
                      context = {
                        componentObject: component.toObject(),
                        rootDistDir,
                        componentDir
                      };

                      // Change the cwd to make sure we found the needed files

                      process.chdir(componentRoot);

                      if (!compiler.action) {
                        _context4.next = 26;
                        break;
                      }

                      _context4.next = 7;
                      return component.getDetachedCompiler(consumer);

                    case 7:
                      isCompilerDetached = _context4.sent;
                      shouldWriteConfig = compiler.writeConfigFilesOnAction && isCompilerDetached;
                      // Write config files to tmp folder

                      if (!shouldWriteConfig) {
                        _context4.next = 14;
                        break;
                      }

                      tmpFolderFullPath = component.getTmpFolder(consumerPath);
                      if (verbose) {
                        console.log(`\nwriting config files to ${tmpFolderFullPath}`); // eslint-disable-line no-console
                      }
                      _context4.next = 14;
                      return (0, (_ejectConf || _load_ejectConf()).writeEnvFiles)({
                        configDir: component.getTmpFolder(),
                        env: compiler,
                        consumer,
                        component,
                        deleteOldFiles: false,
                        verbose
                      });

                    case 14:
                      actionParams = {
                        files,
                        rawConfig: compiler.rawConfig,
                        dynamicConfig: compiler.dynamicConfig,
                        configFiles: compiler.files,
                        api: compiler.api,
                        context
                      };
                      // $FlowFixMe we verified above that action is set

                      _context4.next = 17;
                      return Promise.resolve(compiler.action(actionParams));

                    case 17:
                      result = _context4.sent;

                      if (!tmpFolderFullPath) {
                        _context4.next = 23;
                        break;
                      }

                      if (verbose) {
                        console.log(`\ndeleting tmp directory ${tmpFolderFullPath}`); // eslint-disable-line no-console
                      }
                      (_logger || _load_logger()).default.info(`build-components, deleting ${tmpFolderFullPath}`);
                      _context4.next = 23;
                      return (_fsExtra || _load_fsExtra()).default.remove(tmpFolderFullPath);

                    case 23:
                      if (!(!result || !result.files)) {
                        _context4.next = 25;
                        break;
                      }

                      throw new Error('compiler return invalid response');

                    case 25:
                      return _context4.abrupt('return', result.files);

                    case 26:
                      if (compiler.oldAction) {
                        _context4.next = 28;
                        break;
                      }

                      throw new (_invalidCompilerInterface || _load_invalidCompilerInterface()).default(compiler.name);

                    case 28:
                      return _context4.abrupt('return', Promise.resolve(compiler.oldAction(files, rootDistDir, context)));

                    case 29:
                    case 'end':
                      return _context4.stop();
                  }
                }
              }, _callee4, undefined);
            }))).catch(function (e) {
              if (tmpFolderFullPath) {
                (_logger || _load_logger()).default.info(`build-components, deleting ${tmpFolderFullPath}`);
                (_fsExtra || _load_fsExtra()).default.removeSync(tmpFolderFullPath);
              }
              var errors = e.errors || [e];
              var err = new (_externalBuildErrors || _load_externalBuildErrors()).default(component.id.toString(), errors);
              throw err;
            }));

          case 10:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function _runBuild(_x6) {
    return _ref6.apply(this, arguments);
  };
}();