'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports._verboseMsg = _verboseMsg;

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _vinyl;

function _load_vinyl() {
  return _vinyl = _interopRequireDefault(require('vinyl'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../../logger/logger'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _source;

function _load_source() {
  return _source = _interopRequireDefault(require('../../../scope/models/source'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AbstractVinyl = function (_Vinyl) {
  _inherits(AbstractVinyl, _Vinyl);

  function AbstractVinyl() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, AbstractVinyl);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AbstractVinyl.__proto__ || Object.getPrototypeOf(AbstractVinyl)).call.apply(_ref, [this].concat(args))), _this), _this.override = true, _this.verbose = false, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(AbstractVinyl, [{
    key: 'updatePaths',


    // Update the base path and keep the relative value to be the same
    value: function updatePaths(_ref2) {
      var newBase = _ref2.newBase,
          newRelative = _ref2.newRelative,
          newCwd = _ref2.newCwd;

      var relative = newRelative || this.relative;
      if (newCwd) this.cwd = newCwd;
      this.base = newBase;
      this.path = (_path || _load_path()).default.join(this.base, relative);
    }
  }, {
    key: 'write',
    value: function () {
      var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(writePath) {
        var override = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.override;
        var verbose = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.verbose;
        var filePath, msg;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                filePath = writePath || this.path;
                msg = _verboseMsg(filePath, override);

                if (verbose) {
                  console.log(msg); // eslint-disable-line no-console
                }
                (_logger || _load_logger()).default.debug(msg);

                if (!(!override && (_fsExtra || _load_fsExtra()).default.existsSync(filePath))) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt('return', null);

              case 6:
                _context.next = 8;
                return (_fsExtra || _load_fsExtra()).default.outputFile(filePath, (_utils || _load_utils()).eol.auto(this.contents, this.relative));

              case 8:
                return _context.abrupt('return', filePath);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function write(_x) {
        return _ref3.apply(this, arguments);
      }

      return write;
    }()
  }, {
    key: 'toReadableString',
    value: function toReadableString() {
      return {
        relativePath: this.relative,
        content: this.contents.toString()
      };
    }
  }, {
    key: 'toSourceAsLinuxEOL',


    /**
     * before saving component files in the model, their EOL should be converted to Linux format so
     * then when working on the same components in Windows and Linux they won't appear as modified
     */
    value: function toSourceAsLinuxEOL() {
      // $FlowFixMe
      return (_source || _load_source()).default.from((_utils || _load_utils()).eol.lf(this.contents, this.relative));
    }
  }], [{
    key: 'loadFromParsedString',
    value: function loadFromParsedString(parsedString) {
      var contents = Buffer.isBuffer(parsedString._contents) ? parsedString._contents : Buffer.from(parsedString._contents);
      return {
        cwd: parsedString._cwd,
        path: parsedString.history[parsedString.history.length - 1],
        base: parsedString._base,
        contents
      };
    }
  }, {
    key: 'loadFromParsedStringArray',
    value: function loadFromParsedStringArray(arr) {
      if (!arr) return undefined;
      return arr.map(this.loadFromParsedString);
    }
  }]);

  return AbstractVinyl;
}((_vinyl || _load_vinyl()).default);

/**
 * Generate message for the logs and for output in case of verbose
 * this function is exported for testing purposes
 */


exports.default = AbstractVinyl;
function _verboseMsg(filePath, force) {
  var msg = `writing a file to the file-system at ${filePath}, force: ${force.toString()}`;
  return msg;
}