'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../../error/general-error'));
}

var _configDir;

function _load_configDir() {
  return _configDir = _interopRequireDefault(require('../bit-map/config-dir'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BitStructure = function () {
  function BitStructure(componentsDefaultDirectory, dependenciesDirectory, ejectedEnvsDirectory) {
    _classCallCheck(this, BitStructure);

    this._componentsDefaultDirectoryUnProcessed = componentsDefaultDirectory || (_constants || _load_constants()).DEFAULT_COMPONENTS_DIR_PATH;
    this.dependenciesDirectory = dependenciesDirectory || (_constants || _load_constants()).DEFAULT_DEPENDENCIES_DIR_PATH;
    this.ejectedEnvsDirectory = ejectedEnvsDirectory || (_constants || _load_constants()).DEFAULT_EJECTED_ENVS_DIR_PATH;
  }

  _createClass(BitStructure, [{
    key: '_getComponentStructurePart',
    value: function _getComponentStructurePart(componentStructure, componentPart) {
      switch (componentPart) {
        case 'name':
        case 'scope':
        case 'version':
          return componentPart;
        case 'namespace':
          (_logger || _load_logger()).default.warn('your bit.json has an obsolete "namespace" set in componentsDefaultDirectory property, it has been ignored');
          return ''; // this the dynamic namespace feature, the namespace doesn't exist, it's part of the name
        default:
          throw new (_generalError || _load_generalError()).default(`the "${componentPart}" part of the component structure "${componentStructure}" is invalid, it must be one of the following: "name", "scope" or "version" `);
      }
    }
  }, {
    key: 'dependenciesDirStructure',
    get: function get() {
      return this.dependenciesDirectory;
    }
  }, {
    key: 'ejectedEnvsDirStructure',
    get: function get() {
      return new (_configDir || _load_configDir()).default(this.ejectedEnvsDirectory);
    }
  }, {
    key: 'componentsDefaultDirectory',
    get: function get() {
      var _this = this;

      if (!this._componentsDefaultDirectory) {
        var dirStructure = this._componentsDefaultDirectoryUnProcessed;
        var dirStructureParsed = [];
        dirStructure.split('/').forEach(function (dir) {
          if (dir.startsWith('{') && dir.endsWith('}')) {
            // this is a dynamic parameter
            var dirStripped = dir.replace(/[{}]/g, '');
            var componentPart = _this._getComponentStructurePart(dirStructure, dirStripped);
            if (componentPart) dirStructureParsed.push(`{${componentPart}}`);
          } else {
            dirStructureParsed.push(dir);
          }
        });
        this._componentsDefaultDirectory = dirStructureParsed.join('/');
      }
      return this._componentsDefaultDirectory;
    }
  }]);

  return BitStructure;
}();

exports.default = BitStructure;