'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _diagnosis;

function _load_diagnosis() {
  return _diagnosis = _interopRequireDefault(require('../diagnosis'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../consumer');
}

var _models;

function _load_models() {
  return _models = require('../../scope/models');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OrphanSymlinkObjects = function (_Diagnosis) {
  _inherits(OrphanSymlinkObjects, _Diagnosis);

  function OrphanSymlinkObjects() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, OrphanSymlinkObjects);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = OrphanSymlinkObjects.__proto__ || Object.getPrototypeOf(OrphanSymlinkObjects)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'orphan-symlink-objects', _this.description = 'validate that objects do not have symlinks that point to non exist components', _this.category = 'bit-core-files', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(OrphanSymlinkObjects, [{
    key: '_formatSymptoms',
    value: function _formatSymptoms(bareResult) {
      if (!bareResult.data) throw new Error('OrphanSymlinkObjects, bareResult.data is missing');
      return `the following symlink objects point to non-exist components "${bareResult.data.orphanSymlinks.toString()}"`;
    }
  }, {
    key: '_formatManualTreat',
    value: function _formatManualTreat(bareResult) {
      if (!bareResult.data) throw new Error('OrphanSymlinkObjects, bareResult.data is missing');
      return `please delete the following paths:\n${bareResult.data.objectsToDelete.join('\n')}`;
    }
  }, {
    key: '_runExamine',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2() {
        var _this2 = this;

        var consumer, bitObjects, symlinks, orphanSymlinks, objectsToDelete;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, (_consumer || _load_consumer()).loadConsumer)();

              case 2:
                consumer = _context2.sent;
                _context2.next = 5;
                return consumer.scope.objects.list();

              case 5:
                bitObjects = _context2.sent;
                symlinks = bitObjects.filter(function (object) {
                  return object instanceof (_models || _load_models()).Symlink;
                });
                orphanSymlinks = new (_bitId || _load_bitId()).BitIds();
                objectsToDelete = [];
                _context2.next = 11;
                return Promise.all(symlinks.map(function () {
                  var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(symlink) {
                    var realComponentId, realModelComponent, foundComponent;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            realComponentId = symlink.getRealComponentId();
                            realModelComponent = (_models || _load_models()).ModelComponent.fromBitId(realComponentId);
                            _context.next = 4;
                            return consumer.scope.objects.load(realModelComponent.hash());

                          case 4:
                            foundComponent = _context.sent;

                            if (!foundComponent) {
                              orphanSymlinks.push(realComponentId);
                              objectsToDelete.push(consumer.scope.objects.objectPath(symlink.hash()));
                            }

                          case 6:
                          case 'end':
                            return _context.stop();
                        }
                      }
                    }, _callee, _this2);
                  }));

                  return function (_x) {
                    return _ref3.apply(this, arguments);
                  };
                }()));

              case 11:
                return _context2.abrupt('return', {
                  valid: orphanSymlinks.length === 0,
                  data: {
                    orphanSymlinks,
                    objectsToDelete
                  }
                });

              case 12:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _runExamine() {
        return _ref2.apply(this, arguments);
      }

      return _runExamine;
    }()
  }]);

  return OrphanSymlinkObjects;
}((_diagnosis || _load_diagnosis()).default);

exports.default = OrphanSymlinkObjects;