'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _execa;

function _load_execa() {
  return _execa = _interopRequireDefault(require('execa'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _diagnosis;

function _load_diagnosis() {
  return _diagnosis = _interopRequireDefault(require('../diagnosis'));
}

var _gitExecutable;

function _load_gitExecutable() {
  return _gitExecutable = _interopRequireDefault(require('../../utils/git/git-executable'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ValidateGitExe = function (_Diagnosis) {
  _inherits(ValidateGitExe, _Diagnosis);

  function ValidateGitExe() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ValidateGitExe);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ValidateGitExe.__proto__ || Object.getPrototypeOf(ValidateGitExe)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'validate-git-exe', _this.description = 'validate that git executable found', _this.category = '3rd-parties', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ValidateGitExe, [{
    key: '_formatSymptoms',
    value: function _formatSymptoms(bareResult) {
      var gitExecutablePath = (_ramda || _load_ramda()).default.path(['data', 'gitExecutablePath'], bareResult);
      return `git executable not found (on path '${gitExecutablePath}')`;
    }
  }, {
    key: '_formatManualTreat',
    value: function _formatManualTreat() {
      return "please ensure git is installed and/or git_path is configured using the 'bit config set git_path <GIT_PATH>'";
    }
  }, {
    key: '_runExamine',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var gitExecutablePath;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                gitExecutablePath = (0, (_gitExecutable || _load_gitExecutable()).default)();
                _context.prev = 1;
                _context.next = 4;
                return (0, (_execa || _load_execa()).default)(gitExecutablePath, ['--version']);

              case 4:
                return _context.abrupt('return', {
                  valid: true
                });

              case 7:
                _context.prev = 7;
                _context.t0 = _context['catch'](1);
                return _context.abrupt('return', {
                  valid: false,
                  data: {
                    gitExecutablePath
                  }
                });

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 7]]);
      }));

      function _runExamine() {
        return _ref2.apply(this, arguments);
      }

      return _runExamine;
    }()
  }]);

  return ValidateGitExe;
}((_diagnosis || _load_diagnosis()).default);

exports.default = ValidateGitExe;