'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _diagnosis;

function _load_diagnosis() {
  return _diagnosis = _interopRequireDefault(require('../diagnosis'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../consumer');
}

var _workspaceConfig;

function _load_workspaceConfig() {
  return _workspaceConfig = _interopRequireDefault(require('../../consumer/config/workspace-config'));
}

var _abstractConfig;

function _load_abstractConfig() {
  return _abstractConfig = _interopRequireDefault(require('../../consumer/config/abstract-config'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ValidateWorkspaceBitJsonSyntax = function (_Diagnosis) {
  _inherits(ValidateWorkspaceBitJsonSyntax, _Diagnosis);

  function ValidateWorkspaceBitJsonSyntax() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ValidateWorkspaceBitJsonSyntax);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ValidateWorkspaceBitJsonSyntax.__proto__ || Object.getPrototypeOf(ValidateWorkspaceBitJsonSyntax)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'validate-workspace-bit-json-syntax', _this.description = 'validate workspace bit.json', _this.category = 'bit-core-files', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ValidateWorkspaceBitJsonSyntax, [{
    key: '_formatSymptoms',
    value: function _formatSymptoms(bareResult) {
      var bitJsonPath = (_ramda || _load_ramda()).default.path(['data', 'bitJsonPath'], bareResult);
      return `invalid bit.json: ${bitJsonPath} is not a valid JSON file.`;
    }
  }, {
    key: '_formatManualTreat',
    value: function _formatManualTreat() {
      return 'Manually fix the bit.json or consider running bit init --reset to recreate the file';
    }
  }, {
    key: '_runExamine',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var consumer, consumerPath, bitJsonPath, exist;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, (_consumer || _load_consumer()).loadConsumer)();

              case 2:
                consumer = _context.sent;
                consumerPath = consumer.getPath();
                bitJsonPath = (_abstractConfig || _load_abstractConfig()).default.composeBitJsonPath(consumerPath);
                _context.next = 7;
                return (_fsExtra || _load_fsExtra()).default.exists(bitJsonPath);

              case 7:
                exist = _context.sent;

                if (exist) {
                  _context.next = 10;
                  break;
                }

                return _context.abrupt('return', {
                  valid: true
                });

              case 10:
                _context.prev = 10;

                (_workspaceConfig || _load_workspaceConfig()).default.loadBitJson(bitJsonPath);
                return _context.abrupt('return', {
                  valid: true
                });

              case 15:
                _context.prev = 15;
                _context.t0 = _context['catch'](10);
                return _context.abrupt('return', {
                  valid: false,
                  data: {
                    bitJsonPath
                  }
                });

              case 18:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[10, 15]]);
      }));

      function _runExamine() {
        return _ref2.apply(this, arguments);
      }

      return _runExamine;
    }()
  }]);

  return ValidateWorkspaceBitJsonSyntax;
}((_diagnosis || _load_diagnosis()).default);

exports.default = ValidateWorkspaceBitJsonSyntax;