'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = registerCoreAndExtensionsDiagnoses;

var _doctorRegistrar;

function _load_doctorRegistrar() {
  return _doctorRegistrar = _interopRequireDefault(require('./doctor-registrar'));
}

var _diagnosis;

function _load_diagnosis() {
  return _diagnosis = _interopRequireDefault(require('./diagnosis'));
}

var _validateWorkspaceBitJsonSyntax;

function _load_validateWorkspaceBitJsonSyntax() {
  return _validateWorkspaceBitJsonSyntax = _interopRequireDefault(require('./core-diagnoses/validate-workspace-bit-json-syntax'));
}

var _validateGitExe;

function _load_validateGitExe() {
  return _validateGitExe = _interopRequireDefault(require('./core-diagnoses/validate-git-exe'));
}

var _orphanSymlinkObjects;

function _load_orphanSymlinkObjects() {
  return _orphanSymlinkObjects = _interopRequireDefault(require('./core-diagnoses/orphan-symlink-objects'));
}

var _brokenSymlinkFiles;

function _load_brokenSymlinkFiles() {
  return _brokenSymlinkFiles = _interopRequireDefault(require('./core-diagnoses/broken-symlink-files'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function registerCoreAndExtensionsDiagnoses() {
  var extensionDiagnoses = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var diagnoses = [new (_validateWorkspaceBitJsonSyntax || _load_validateWorkspaceBitJsonSyntax()).default(), new (_validateGitExe || _load_validateGitExe()).default(), new (_orphanSymlinkObjects || _load_orphanSymlinkObjects()).default(), new (_brokenSymlinkFiles || _load_brokenSymlinkFiles()).default()].concat(extensionDiagnoses);
  (_doctorRegistrar || _load_doctorRegistrar()).default.init(diagnoses);
}