'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var loadFromConfig = function () {
  var _ref10 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(_ref11) {
    var envConfig = _ref11.envConfig,
        envType = _ref11.envType,
        consumerPath = _ref11.consumerPath,
        scopePath = _ref11.scopePath,
        configPath = _ref11.configPath,
        context = _ref11.context;
    var env, envName, envObject, envProps;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            env = envConfig[envType];

            if (env) {
              _context8.next = 3;
              break;
            }

            return _context8.abrupt('return', null);

          case 3:
            envName = Object.keys(env)[0];
            envObject = env[envName];
            envProps = {
              name: envName,
              consumerPath,
              scopePath,
              rawConfig: envObject.rawConfig,
              files: envObject.files,
              bitJsonPath: configPath,
              options: envObject.options,
              envType,
              context
            };
            // $FlowFixMe

            return _context8.abrupt('return', (0, (_envFactory || _load_envFactory()).default)(envType, envProps));

          case 7:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  return function loadFromConfig(_x15) {
    return _ref10.apply(this, arguments);
  };
}();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _stringFormat;

function _load_stringFormat() {
  return _stringFormat = _interopRequireDefault(require('string-format'));
}

var _baseExtension;

function _load_baseExtension() {
  return _baseExtension = _interopRequireDefault(require('./base-extension'));
}

var _bitId;

function _load_bitId() {
  return _bitId = _interopRequireDefault(require('../bit-id/bit-id'));
}

var _extensionFile;

function _load_extensionFile() {
  return _extensionFile = _interopRequireDefault(require('./extension-file'));
}

var _objects;

function _load_objects() {
  return _objects = require('../scope/objects');
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _removeFilesAndEmptyDirsRecursively;

function _load_removeFilesAndEmptyDirsRecursively() {
  return _removeFilesAndEmptyDirsRecursively = _interopRequireDefault(require('../utils/fs/remove-files-and-empty-dirs-recursively'));
}

var _scope;

function _load_scope() {
  return _scope = require('../scope');
}

var _analytics;

function _load_analytics() {
  return _analytics = require('../analytics/analytics');
}

var _extensionGetDynamicPackagesError;

function _load_extensionGetDynamicPackagesError() {
  return _extensionGetDynamicPackagesError = _interopRequireDefault(require('./exceptions/extension-get-dynamic-packages-error'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _dependencies;

function _load_dependencies() {
  return _dependencies = require('../consumer/component/dependencies');
}

var _configDir;

function _load_configDir() {
  return _configDir = _interopRequireDefault(require('../consumer/bit-map/config-dir'));
}

var _extensionGetDynamicConfigError;

function _load_extensionGetDynamicConfigError() {
  return _extensionGetDynamicConfigError = _interopRequireDefault(require('./exceptions/extension-get-dynamic-config-error'));
}

var _installExtensions;

function _load_installExtensions() {
  return _installExtensions = _interopRequireDefault(require('../scope/extensions/install-extensions'));
}

var _dataToPersist;

function _load_dataToPersist() {
  return _dataToPersist = _interopRequireDefault(require('../consumer/component/sources/data-to-persist'));
}

var _removePath;

function _load_removePath() {
  return _removePath = _interopRequireDefault(require('../consumer/component/sources/remove-path'));
}

var _abstractConfig;

function _load_abstractConfig() {
  return _abstractConfig = _interopRequireDefault(require('../consumer/config/abstract-config'));
}

var _envFactory;

function _load_envFactory() {
  return _envFactory = _interopRequireDefault(require('./env-factory'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Couldn't find a good way to do this with consts
// see https://github.com/facebook/flow/issues/627
// I would expect something like:
// type EnvType = CompilerEnvType | TesterEnvType would work
var EnvExtension = function (_BaseExtension) {
  _inherits(EnvExtension, _BaseExtension);

  _createClass(EnvExtension, [{
    key: 'action',


    /**
     * Return the action
     */
    get: function get() {
      if (this.script && this.script.action && typeof this.script.action === 'function') {
        return this.script.action;
      }
      return undefined;
    }

    /**
     * return old actions (to support old compilers / testers which uses run / compile functions)
     */

  }, {
    key: 'oldAction',
    get: function get() {
      if (this.script && this.script.run && typeof this.script.run === 'function') {
        return this.script.run;
      }
      if (this.script && this.script.compile && typeof this.script.compile === 'function') {
        return this.script.compile;
      }
      return undefined;
    }
  }]);

  function EnvExtension(extensionProps) {
    _classCallCheck(this, EnvExtension);

    var _this = _possibleConstructorReturn(this, (EnvExtension.__proto__ || Object.getPrototypeOf(EnvExtension)).call(this, extensionProps));

    _this.envType = extensionProps.envType;
    _this.dynamicPackageDependencies = extensionProps.dynamicPackageDependencies;
    _this.files = extensionProps.files;
    return _this;
  }

  _createClass(EnvExtension, [{
    key: 'install',
    value: function () {
      var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(scope, opts, context) {
        var dependentId, installOpts, installResult;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('env-extension', 'install env extension');
                (_logger || _load_logger()).default.debug('env-extension - install env extension');

                // Skip the installation in case of using specific file
                // options.file usually used for develop your extension

                if (!this.options.file) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt('return', undefined);

              case 4:
                dependentId = (_ramda || _load_ramda()).default.path(['dependentId'], context);
                installOpts = _extends({
                  ids: [{ componentId: (_bitId || _load_bitId()).default.parse(this.name, true), type: this.envType.toLowerCase() }], // @todo: make sure it always has a scope name
                  dependentId,
                  scope
                }, opts);
                _context.next = 8;
                return (0, (_installExtensions || _load_installExtensions()).default)(installOpts);

              case 8:
                installResult = _context.sent;

                this.setExtensionPathInScope(scope.getPath());
                _context.next = 12;
                return this.reload(scope.getPath(), context);

              case 12:
                return _context.abrupt('return', installResult);

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function install(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: 'toModelObject',
    value: function toModelObject() {
      var baseObject = _get(EnvExtension.prototype.__proto__ || Object.getPrototypeOf(EnvExtension.prototype), 'toModelObject', this).call(this);
      var files = this.files.map(function (file) {
        return file.toModelObject();
      });
      var modelObject = _extends({ files }, baseObject);
      return modelObject;
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      var baseObject = _get(EnvExtension.prototype.__proto__ || Object.getPrototypeOf(EnvExtension.prototype), 'toObject', this).call(this);
      var files = this.files;
      var object = _extends({}, baseObject, { files });
      return object;
    }

    /**
     * Get a bit.json representation of the env instance
     * @param {string} ejectedEnvDirectory - The base path of where the env config files are stored
     * $FlowFixMe seems to be an issue opened for this https://github.com/facebook/flow/issues/4953
     */

  }, {
    key: 'toBitJsonObject',
    value: function toBitJsonObject(ejectedEnvDirectory) {
      (_logger || _load_logger()).default.debug('env-extension', 'toBitJsonObject');
      var files = {};
      this.files.forEach(function (file) {
        var relativePath = (0, (_utils || _load_utils()).pathJoinLinux)(ejectedEnvDirectory, file.relative);
        files[file.name] = `./${relativePath}`;
      });
      var envVal = {
        rawConfig: this.dynamicConfig,
        options: this.options,
        files
      };
      return {
        [this.name]: envVal
      };
    }
  }, {
    key: 'populateDataToPersist',
    value: function populateDataToPersist(_ref2) {
      var _this2 = this;

      var configDir = _ref2.configDir,
          envType = _ref2.envType,
          deleteOldFiles = _ref2.deleteOldFiles,
          consumer = _ref2.consumer,
          _ref2$verbose = _ref2.verbose,
          verbose = _ref2$verbose === undefined ? false : _ref2$verbose;

      var resolvedEjectedEnvsDirectory = (0, (_stringFormat || _load_stringFormat()).default)(configDir, { ENV_TYPE: envType });
      var filePathsToRemove = [];

      this.files.forEach(function (file) {
        if (deleteOldFiles) {
          var pathToDelete = consumer ? consumer.getPathRelativeToConsumer(file.path) : file.path;
          filePathsToRemove.push(pathToDelete);
        }
        file.updatePaths({ newBase: resolvedEjectedEnvsDirectory, newRelative: file.relative });
        file.verbose = verbose;
      });
      this.dataToPersist = new (_dataToPersist || _load_dataToPersist()).default();
      this.files.forEach(function (file) {
        var cloned = file.clone();
        cloned.verbose = verbose;
        _this2.dataToPersist.addFile(cloned);
      });
      filePathsToRemove.map(function (file) {
        return _this2.dataToPersist.removePath(new (_removePath || _load_removePath()).default(file, true));
      });
      return resolvedEjectedEnvsDirectory;
    }

    /**
     * Delete env files from file system
     */

  }, {
    key: 'removeFilesFromFs',
    value: function () {
      var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(dependencies, configDir, envType, consumerPath) {
        var filePaths, relativeSourcePaths, componentDir, configDirResolved, configDirPath, absoluteEnvsDirectory, linkPaths;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('env-extension', 'removeFilesFromFs');
                filePaths = this.files.map(function (file) {
                  return file.path;
                });
                relativeSourcePaths = dependencies.getSourcesPaths();

                if (this.context) {
                  _context2.next = 5;
                  break;
                }

                throw new Error('env-extension.removeFilesFromFs, this.context is missing');

              case 5:
                componentDir = this.context.componentDir;
                configDirResolved = configDir.getResolved({ componentDir, envType });
                configDirPath = configDirResolved.dirPath;
                absoluteEnvsDirectory = (_path || _load_path()).default.isAbsolute(configDirPath) ? configDirPath : (_path || _load_path()).default.join(consumerPath, configDirPath);
                linkPaths = relativeSourcePaths.map(function (relativePath) {
                  return (_path || _load_path()).default.join(absoluteEnvsDirectory, relativePath);
                });
                return _context2.abrupt('return', (0, (_removeFilesAndEmptyDirsRecursively || _load_removeFilesAndEmptyDirsRecursively()).default)([].concat(_toConsumableArray(filePaths), _toConsumableArray(linkPaths))));

              case 11:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function removeFilesFromFs(_x4, _x5, _x6, _x7) {
        return _ref3.apply(this, arguments);
      }

      return removeFilesFromFs;
    }()
  }, {
    key: 'reload',
    value: function () {
      var _ref4 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(scopePath, context) {
        var throws, dynamicPackageDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                (_logger || _load_logger()).default.debug('env-extension', 'reload');
                if (context) {
                  this.context = context;
                }
                throws = true;
                _context3.next = 5;
                return _get(EnvExtension.prototype.__proto__ || Object.getPrototypeOf(EnvExtension.prototype), 'reload', this).call(this, scopePath, { throws });

              case 5:
                // $FlowFixMe
                dynamicPackageDependencies = EnvExtension.loadDynamicPackageDependencies(this);

                this.dynamicPackageDependencies = dynamicPackageDependencies;

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function reload(_x8, _x9) {
        return _ref4.apply(this, arguments);
      }

      return reload;
    }()

    /**
     * Loading from props (usually from bit.json)
     * @param {*} props
     * $FlowFixMe seems to be an issue opened for this https://github.com/facebook/flow/issues/4953
     */

  }], [{
    key: 'load',
    value: function () {
      var _ref5 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(props) {
        var baseExtensionProps, files, envExtensionProps, dynamicPackageDependencies, dynamicConfig;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return _get(EnvExtension.__proto__ || Object.getPrototypeOf(EnvExtension), 'load', this).call(this, props);

              case 2:
                baseExtensionProps = _context4.sent;
                _context4.next = 5;
                return (_extensionFile || _load_extensionFile()).default.loadFromBitJsonObject(
                // $FlowFixMe
                props.files, // $FlowFixMe
                props.consumerPath, props.bitJsonPath, props.envType);

              case 5:
                files = _context4.sent;
                envExtensionProps = _extends({ envType: props.envType, files }, baseExtensionProps);
                dynamicPackageDependencies = EnvExtension.loadDynamicPackageDependencies(envExtensionProps);

                envExtensionProps.dynamicPackageDependencies = dynamicPackageDependencies;
                dynamicConfig = EnvExtension.loadDynamicConfig(envExtensionProps);
                // $FlowFixMe

                envExtensionProps.dynamicConfig = dynamicConfig;
                return _context4.abrupt('return', envExtensionProps);

              case 12:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function load(_x10) {
        return _ref5.apply(this, arguments);
      }

      return load;
    }()
  }, {
    key: 'loadDynamicPackageDependencies',
    value: function loadDynamicPackageDependencies(envExtensionProps) {
      var getDynamicPackageDependencies = (_ramda || _load_ramda()).default.path(['script', 'getDynamicPackageDependencies'], envExtensionProps);
      if (getDynamicPackageDependencies && typeof getDynamicPackageDependencies === 'function') {
        try {
          var _dynamicPackageDependencies = getDynamicPackageDependencies({
            rawConfig: envExtensionProps.rawConfig,
            dynamicConfig: envExtensionProps.dynamicConfig,
            configFiles: envExtensionProps.files,
            context: envExtensionProps.context
          });
          return _dynamicPackageDependencies;
        } catch (err) {
          throw new (_extensionGetDynamicPackagesError || _load_extensionGetDynamicPackagesError()).default(err, envExtensionProps.name);
        }
      }
      return undefined;
    }

    // $FlowFixMe

  }, {
    key: 'loadDynamicConfig',
    value: function loadDynamicConfig(envExtensionProps) {
      var getDynamicConfig = (_ramda || _load_ramda()).default.path(['script', 'getDynamicConfig'], envExtensionProps);
      if (getDynamicConfig && typeof getDynamicConfig === 'function') {
        try {
          var dynamicConfig = getDynamicConfig({
            rawConfig: envExtensionProps.rawConfig,
            configFiles: envExtensionProps.files,
            context: envExtensionProps.context
          });
          return dynamicConfig;
        } catch (err) {
          throw new (_extensionGetDynamicConfigError || _load_extensionGetDynamicConfigError()).default(err, envExtensionProps.name);
        }
      }
      return undefined;
    }

    /**
     * $FlowFixMe seems to be an issue opened for this https://github.com/facebook/flow/issues/4953
     */

  }, {
    key: 'loadFromModelObject',
    value: function () {
      var _ref6 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(
      // $FlowFixMe
      modelObject, repository) {
        var baseExtensionProps, files, loadFilesP, envExtensionProps;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                // $FlowFixMe
                baseExtensionProps = _get(EnvExtension.__proto__ || Object.getPrototypeOf(EnvExtension), 'loadFromModelObject', this).call(this, modelObject);
                files = [];

                if (!(modelObject.files && !(_ramda || _load_ramda()).default.isEmpty(modelObject.files))) {
                  _context5.next = 7;
                  break;
                }

                loadFilesP = modelObject.files.map(function (file) {
                  return (_extensionFile || _load_extensionFile()).default.loadFromExtensionFileModel(file, repository);
                });
                _context5.next = 6;
                return Promise.all(loadFilesP);

              case 6:
                files = _context5.sent;

              case 7:
                envExtensionProps = _extends({ envType: modelObject.envType, files }, baseExtensionProps);
                return _context5.abrupt('return', envExtensionProps);

              case 9:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function loadFromModelObject(_x11, _x12) {
        return _ref6.apply(this, arguments);
      }

      return loadFromModelObject;
    }()
  }, {
    key: 'loadFromSerializedModelObject',
    value: function () {
      var _ref7 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(modelObject) {
        var baseExtensionProps, files, loadFilesP, envExtensionProps;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                (_logger || _load_logger()).default.debug('env-extension', 'loadFromModelObject');
                // $FlowFixMe
                baseExtensionProps = _get(EnvExtension.__proto__ || Object.getPrototypeOf(EnvExtension), 'loadFromModelObject', this).call(this, modelObject);
                files = [];

                if (!(modelObject.files && !(_ramda || _load_ramda()).default.isEmpty(modelObject.files))) {
                  _context6.next = 8;
                  break;
                }

                loadFilesP = modelObject.files.map(function (file) {
                  return (_extensionFile || _load_extensionFile()).default.loadFromExtensionFileSerializedModel(file);
                });
                _context6.next = 7;
                return Promise.all(loadFilesP);

              case 7:
                files = _context6.sent;

              case 8:
                envExtensionProps = _extends({ envType: modelObject.envType, files }, baseExtensionProps);
                return _context6.abrupt('return', envExtensionProps);

              case 10:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function loadFromSerializedModelObject(_x13) {
        return _ref7.apply(this, arguments);
      }

      return loadFromSerializedModelObject;
    }()

    /**
     * load the compiler/tester according to the following strategies:
     * 1. from component config. (bit.json/package.json of the component) if it was written.
     * 2. from component model. an imported component might not have the config written.
     * for author, it's irrelevant, because upon import it's written to consumer config (if changed).
     * 3. from consumer config overrides. (bit.json/package.json of the consumer when this component
     * overrides the general env config).
     * 4. from consumer config.
     */

  }, {
    key: 'loadFromCorrectSource',
    value: function () {
      var _ref8 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(_ref9) {
        var consumerPath = _ref9.consumerPath,
            scopePath = _ref9.scopePath,
            componentOrigin = _ref9.componentOrigin,
            componentFromModel = _ref9.componentFromModel,
            componentConfig = _ref9.componentConfig,
            overridesFromConsumer = _ref9.overridesFromConsumer,
            workspaceConfig = _ref9.workspaceConfig,
            envType = _ref9.envType,
            context = _ref9.context;

        var envConfig, configPath, _envConfig, _envConfig2;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                (_logger || _load_logger()).default.debug('env-extension', `(${envType}) loadFromCorrectSource`);

                if (!(componentConfig && componentConfig.componentHasWrittenConfig)) {
                  _context7.next = 6;
                  break;
                }

                // load from component config.
                // $FlowFixMe
                envConfig = { [envType]: componentConfig[envType] };
                configPath = (_path || _load_path()).default.dirname(componentConfig.path);

                (_logger || _load_logger()).default.debug(`env-extension loading ${envType} from component config`);
                return _context7.abrupt('return', loadFromConfig({ envConfig, envType, consumerPath, scopePath, configPath, context }));

              case 6:
                if (!(componentOrigin !== (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED)) {
                  _context7.next = 9;
                  break;
                }

                // config was not written into component dir, load the config from the model
                (_logger || _load_logger()).default.debug(`env-extension, loading ${envType} from the model`);
                return _context7.abrupt('return', componentFromModel ? componentFromModel[envType] : undefined);

              case 9:
                if (!(overridesFromConsumer && overridesFromConsumer.env && overridesFromConsumer.env[envType])) {
                  _context7.next = 16;
                  break;
                }

                if (!(overridesFromConsumer.env[envType] === (_constants || _load_constants()).MANUALLY_REMOVE_ENVIRONMENT)) {
                  _context7.next = 13;
                  break;
                }

                (_logger || _load_logger()).default.debug(`env-extension, ${envType} was manually removed from the consumer config overrides`);
                return _context7.abrupt('return', null);

              case 13:
                (_logger || _load_logger()).default.debug(`env-extension, loading ${envType} from the consumer config overrides`);
                // $FlowFixMe
                _envConfig = { [envType]: (_abstractConfig || _load_abstractConfig()).default.transformEnvToObject(overridesFromConsumer.env[envType]) };
                return _context7.abrupt('return', loadFromConfig({ envConfig: _envConfig, envType, consumerPath, scopePath, configPath: consumerPath, context }));

              case 16:
                if (!workspaceConfig[envType]) {
                  _context7.next = 20;
                  break;
                }

                (_logger || _load_logger()).default.debug(`env-extension, loading ${envType} from the consumer config`);
                // $FlowFixMe
                _envConfig2 = { [envType]: workspaceConfig[envType] };
                return _context7.abrupt('return', loadFromConfig({ envConfig: _envConfig2, envType, consumerPath, scopePath, configPath: consumerPath, context }));

              case 20:
                return _context7.abrupt('return', null);

              case 21:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function loadFromCorrectSource(_x14) {
        return _ref8.apply(this, arguments);
      }

      return loadFromCorrectSource;
    }()

    /**
     * are two envs (in the model/scope format) different
     */

  }, {
    key: 'areEnvsDifferent',
    value: function areEnvsDifferent(envModelA, envModelB) {
      var sortEnv = function sortEnv(env) {
        env.files = (_ramda || _load_ramda()).default.sortBy((_ramda || _load_ramda()).default.prop('name'), env.files);
        env.config = (0, (_utils || _load_utils()).sortObject)(env.config);
        var result = (0, (_utils || _load_utils()).sortObject)(env);
        return result;
      };
      var stringifyEnv = function stringifyEnv(env) {
        if (!env) {
          return '';
        }
        if (typeof env === 'string') {
          return env;
        }
        return JSON.stringify(sortEnv(env));
      };
      var envModelAString = stringifyEnv(envModelA);
      var envModelBString = stringifyEnv(envModelB);
      return (0, (_utils || _load_utils()).sha1)(envModelAString) !== (0, (_utils || _load_utils()).sha1)(envModelBString);
    }
  }]);

  return EnvExtension;
}((_baseExtension || _load_baseExtension()).default);

exports.default = EnvExtension;