'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var parseNpmListJsonGracefully = function () {
  var _ref4 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(str, packageManager) {
    var json, version;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            json = JSON.parse(str);
            return _context2.abrupt('return', json);

          case 5:
            _context2.prev = 5;
            _context2.t0 = _context2['catch'](0);

            (_logger || _load_logger()).default.error(_context2.t0);

            if (!(packageManager === 'npm')) {
              _context2.next = 15;
              break;
            }

            _context2.next = 11;
            return getNpmVersion();

          case 11:
            version = _context2.sent;

            (_analytics || _load_analytics()).Analytics.setExtraData('npmVersion', version);

            if (!(version && (_semver || _load_semver()).default.gte(version, '5.0.0') && (_semver || _load_semver()).default.lt(version, '5.1.0'))) {
              _context2.next = 15;
              break;
            }

            throw new Error(`error: your npm version "${version}" has issues returning json, please upgrade to 5.1.0 or above (npm install -g npm@5.1.0)`);

          case 15:
            throw new Error(`failed parsing the output of npm list due to an error: ${_context2.t0.message}`);

          case 16:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 5]]);
  }));

  return function parseNpmListJsonGracefully(_x2, _x3) {
    return _ref4.apply(this, arguments);
  };
}();

/**
 * A wrapper function to call the install
 * then get the peers
 * then install the peers
 */


var getNpmVersion = function () {
  var _ref10 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5() {
    var _ref11, _stdout, _stderr;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.prev = 0;
            _context5.next = 3;
            return (0, (_execa || _load_execa()).default)('npm', ['--version']);

          case 3:
            _ref11 = _context5.sent;
            _stdout = _ref11.stdout;
            _stderr = _ref11.stderr;

            if (!(_stdout && !_stderr)) {
              _context5.next = 8;
              break;
            }

            return _context5.abrupt('return', _stdout);

          case 8:
            _context5.next = 13;
            break;

          case 10:
            _context5.prev = 10;
            _context5.t0 = _context5['catch'](0);

            (_logger || _load_logger()).default.debug(`got an error when executing "npm --version". ${_context5.t0.message}`);

          case 13:
            return _context5.abrupt('return', null);

          case 14:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this, [[0, 10]]);
  }));

  return function getNpmVersion() {
    return _ref10.apply(this, arguments);
  };
}();

/**
 * a situation where rootDir and subDir have package.json, some of the packages may be shared
 * and some may be conflicted. And the "npm/yarn install" is done from the root dir.
 * package managers install the shared packages only once in the rootDir.
 * however, as to the conflicted packages, only npm@5 and above install it in the subDir.
 * others, install it in the root, which, result in an incorrect package resolution for the subDir.
 */


var isSupportedInstallationOfSubDirFromRoot = function () {
  var _ref12 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(packageManager) {
    var version;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            if (!(packageManager === 'npm')) {
              _context6.next = 6;
              break;
            }

            _context6.next = 3;
            return getNpmVersion();

          case 3:
            version = _context6.sent;

            if (!(version && (_semver || _load_semver()).default.gte(version, '5.0.0'))) {
              _context6.next = 6;
              break;
            }

            return _context6.abrupt('return', true);

          case 6:
            return _context6.abrupt('return', false);

          case 7:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function isSupportedInstallationOfSubDirFromRoot(_x6) {
    return _ref12.apply(this, arguments);
  };
}();

var _execa;

function _load_execa() {
  return _execa = _interopRequireDefault(require('execa'));
}

var _pMapSeries;

function _load_pMapSeries() {
  return _pMapSeries = _interopRequireDefault(require('p-map-series'));
}

var _semver;

function _load_semver() {
  return _semver = _interopRequireDefault(require('semver'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _ramda2;

function _load_ramda2() {
  return _ramda2 = require('ramda');
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../error/general-error'));
}

var _analytics;

function _load_analytics() {
  return _analytics = require('../analytics/analytics');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var objectToArray = function objectToArray(obj) {
  return (0, (_ramda2 || _load_ramda2()).map)((0, (_ramda2 || _load_ramda2()).join)('@'), (0, (_ramda2 || _load_ramda2()).toPairs)(obj));
};
var rejectNils = (_ramda || _load_ramda()).default.reject((_ramda2 || _load_ramda2()).isNil);

var defaultNpmArgs = [];
var defaultYarnArgs = [];
var defaultPackageManagerArgs = {
  npm: defaultNpmArgs,
  yarn: defaultYarnArgs
};
var defaultPackageManagerProcessOptions = {
  cwd: process.cwd
};
var warningPrefix = function warningPrefix(packageManager) {
  return packageManager === 'npm' ? 'npm WARN' : 'warning';
};
var errorPrefix = function errorPrefix(packageManager) {
  return packageManager === 'npm' ? 'npm ERR!' : 'error';
};
var peerDependenciesMissing = function peerDependenciesMissing(packageManager) {
  return packageManager === 'npm' ? 'requires a peer' : 'unmet peer';
};

var stripNonNpmErrors = function stripNonNpmErrors(errors, packageManager) {
  // a workaround to remove all 'npm warn' and 'npm notice'.
  // NPM itself returns them even when --loglevel = error or when --silent/--quiet flags are set
  var prefix = errorPrefix(packageManager);
  return errors.split('\n').filter(function (error) {
    return error.startsWith(prefix);
  }).join('\n');
};

var stripNonPeerDependenciesWarnings = function stripNonPeerDependenciesWarnings(errors, packageManager) {
  var prefix = warningPrefix(packageManager);
  var peer = peerDependenciesMissing(packageManager);
  return errors.split('\n').filter(function (error) {
    return error.startsWith(prefix) && error.includes(peer);
  }).join('\n');
};

/**
 * Pick only allowed to be overridden options
 * @param {Object} userOptions
 */
var getAllowdPackageManagerProcessOptions = function getAllowdPackageManagerProcessOptions(userOptions) {
  var allowdOptions = ['shell', 'env', 'extendEnv', 'uid', 'gid', 'preferLocal', 'localDir', 'timeout'];
  return (_ramda || _load_ramda()).default.pick(allowdOptions, userOptions);
};

/**
 * Install packages in specific directory
 */
var _installInOneDirectory = function _installInOneDirectory(_ref) {
  var _ref$modules = _ref.modules,
      modules = _ref$modules === undefined ? [] : _ref$modules,
      _ref$packageManager = _ref.packageManager,
      packageManager = _ref$packageManager === undefined ? (_constants || _load_constants()).DEFAULT_PACKAGE_MANAGER : _ref$packageManager,
      _ref$packageManagerAr = _ref.packageManagerArgs,
      packageManagerArgs = _ref$packageManagerAr === undefined ? [] : _ref$packageManagerAr,
      _ref$packageManagerPr = _ref.packageManagerProcessOptions,
      packageManagerProcessOptions = _ref$packageManagerPr === undefined ? {} : _ref$packageManagerPr,
      dir = _ref.dir,
      _ref$verbose = _ref.verbose,
      verbose = _ref$verbose === undefined ? false : _ref$verbose;

  // Handle process options
  var allowedPackageManagerProcessOptions = getAllowdPackageManagerProcessOptions(packageManagerProcessOptions);
  var concretePackageManagerProcessOptions = (0, (_ramda2 || _load_ramda2()).merge)(defaultPackageManagerProcessOptions, allowedPackageManagerProcessOptions);
  concretePackageManagerProcessOptions.cwd = dir || concretePackageManagerProcessOptions.cwd;
  var cwd = concretePackageManagerProcessOptions.cwd;

  // taking care of object case
  var processedModules = (0, (_ramda2 || _load_ramda2()).is)(Object, modules) && !Array.isArray(modules) ? objectToArray(modules) : modules;

  // Handle process args
  var concretePackageManagerDefaultArgs = ['install'].concat(_toConsumableArray(processedModules), _toConsumableArray(defaultPackageManagerArgs[packageManager]));
  var concretePackageManagerArgs = rejectNils((_ramda || _load_ramda()).default.concat(concretePackageManagerDefaultArgs, packageManagerArgs));

  // Add npm verbose flag
  if (verbose && packageManager === 'npm') {
    // we may want to use it later. For now, it print too much information
    // concretePackageManagerArgs.push('--verbose');
  }

  (_fsExtra || _load_fsExtra()).default.ensureDirSync((_path || _load_path()).default.join(cwd, 'node_modules'));
  (_logger || _load_logger()).default.debug(`installing npm packages using ${packageManager} at ${cwd} with options:`, concretePackageManagerProcessOptions, `and args: ${concretePackageManagerArgs}`);

  // Set the shell to true to prevent problems with post install scripts when running as root
  var packageManagerClientName = packageManager;
  var childProcess = (0, (_execa || _load_execa()).default)(packageManagerClientName, concretePackageManagerArgs, concretePackageManagerProcessOptions);

  // Remove the install from args since it's always there
  var printArgs = concretePackageManagerArgs.filter(function (arg) {
    return arg !== 'install';
  });
  var argsString = printArgs && printArgs.length > 0 ? `with args: ${printArgs}` : '';

  return childProcess.then(function (_ref2) {
    var stdout = _ref2.stdout,
        stderr = _ref2.stderr;

    var successMessage = `\nsuccessfully ran ${packageManager} install at ${cwd} ${argsString}`;
    var peerWarnings = stripNonPeerDependenciesWarnings(stderr, packageManager);

    stdout = verbose ? stdout + successMessage : (_chalk || _load_chalk()).default.white(peerWarnings) + successMessage;
    stderr = verbose ? stderr : '';
    return { stdout, stderr };
  }).catch(function (err) {
    var stderr = `failed running ${packageManager} install at ${cwd} ${argsString}  \n`;
    stderr += verbose ? err.stderr : stripNonNpmErrors(err.stderr, packageManager);
    return Promise.reject(new (_generalError || _load_generalError()).default(`${stderr}\n\n${(_chalk || _load_chalk()).default.yellow(`see troubleshooting at https://${(_constants || _load_constants()).BASE_DOCS_DOMAIN}/docs/install-components.html`)}`));
  });
};

/**
 * Get peer dependencies for directory
 * you should run this after you run npm install
 * internally it uses npm list -j
 */
var _getPeerDeps = function () {
  var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(dir) {
    var packageManager, parsePeers, npmList, npmListObject, peers;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            packageManager = (_constants || _load_constants()).DEFAULT_PACKAGE_MANAGER;

            parsePeers = function parsePeers(deps) {
              var result = {};
              (_ramda || _load_ramda()).default.forEachObjIndexed(function (dep) {
                if (dep.peerMissing) {
                  var name = dep.required.name;
                  var version = dep.required.version;
                  result[name] = version;
                }
              }, deps);
              return result;
            };

            npmList = void 0;
            _context.prev = 3;
            _context.next = 6;
            return (0, (_execa || _load_execa()).default)(packageManager, ['list', '-j'], { cwd: dir });

          case 6:
            npmList = _context.sent;
            _context.next = 17;
            break;

          case 9:
            _context.prev = 9;
            _context.t0 = _context['catch'](3);

            if (!(_context.t0.stdout && _context.t0.stdout.startsWith('{'))) {
              _context.next = 15;
              break;
            }

            // it's probably a valid json with errors, that's fine, parse it.
            npmList = _context.t0;
            _context.next = 17;
            break;

          case 15:
            (_logger || _load_logger()).default.error(_context.t0);
            throw new Error(`failed running ${_context.t0.cmd} to find the peer dependencies due to an error: ${_context.t0.message}`);

          case 17:
            _context.next = 19;
            return parseNpmListJsonGracefully(npmList.stdout, packageManager);

          case 19:
            npmListObject = _context.sent;
            peers = parsePeers(npmListObject.dependencies);
            return _context.abrupt('return', peers);

          case 22:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[3, 9]]);
  }));

  return function _getPeerDeps(_x) {
    return _ref3.apply(this, arguments);
  };
}();

var _installInOneDirectoryWithPeerOption = function () {
  var _ref5 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(_ref6) {
    var _ref6$modules = _ref6.modules,
        modules = _ref6$modules === undefined ? [] : _ref6$modules,
        _ref6$packageManager = _ref6.packageManager,
        packageManager = _ref6$packageManager === undefined ? (_constants || _load_constants()).DEFAULT_PACKAGE_MANAGER : _ref6$packageManager,
        _ref6$packageManagerA = _ref6.packageManagerArgs,
        packageManagerArgs = _ref6$packageManagerA === undefined ? [] : _ref6$packageManagerA,
        _ref6$packageManagerP = _ref6.packageManagerProcessOptions,
        packageManagerProcessOptions = _ref6$packageManagerP === undefined ? {} : _ref6$packageManagerP,
        dir = _ref6.dir,
        _ref6$installPeerDepe = _ref6.installPeerDependencies,
        installPeerDependencies = _ref6$installPeerDepe === undefined ? false : _ref6$installPeerDepe,
        _ref6$verbose = _ref6.verbose,
        verbose = _ref6$verbose === undefined ? false : _ref6$verbose;
    var rootDirResults, peers, peerResults;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _installInOneDirectory({
              modules,
              packageManager,
              packageManagerArgs,
              packageManagerProcessOptions,
              dir,
              installPeerDependencies,
              verbose
            });

          case 2:
            rootDirResults = _context3.sent;

            if (!installPeerDependencies) {
              _context3.next = 11;
              break;
            }

            _context3.next = 6;
            return _getPeerDeps(dir);

          case 6:
            peers = _context3.sent;
            _context3.next = 9;
            return _installInOneDirectory({
              modules: peers,
              packageManager,
              packageManagerArgs,
              packageManagerProcessOptions,
              dir,
              verbose
            });

          case 9:
            peerResults = _context3.sent;
            return _context3.abrupt('return', [rootDirResults, peerResults]);

          case 11:
            return _context3.abrupt('return', rootDirResults);

          case 12:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function _installInOneDirectoryWithPeerOption(_x4) {
    return _ref5.apply(this, arguments);
  };
}();

/**
 * when modules is empty, it runs 'npm install' without any package, which installs according to package.json file
 */
var installAction = function () {
  var _ref7 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(_ref8) {
    var modules = _ref8.modules,
        _ref8$packageManager = _ref8.packageManager,
        packageManager = _ref8$packageManager === undefined ? (_constants || _load_constants()).DEFAULT_PACKAGE_MANAGER : _ref8$packageManager,
        _ref8$packageManagerA = _ref8.packageManagerArgs,
        packageManagerArgs = _ref8$packageManagerA === undefined ? [] : _ref8$packageManagerA,
        _ref8$packageManagerP = _ref8.packageManagerProcessOptions,
        packageManagerProcessOptions = _ref8$packageManagerP === undefined ? {} : _ref8$packageManagerP,
        _ref8$useWorkspaces = _ref8.useWorkspaces,
        useWorkspaces = _ref8$useWorkspaces === undefined ? false : _ref8$useWorkspaces,
        _ref8$dirs = _ref8.dirs,
        dirs = _ref8$dirs === undefined ? [] : _ref8$dirs,
        rootDir = _ref8.rootDir,
        _ref8$installRootPack = _ref8.installRootPackageJson,
        installRootPackageJson = _ref8$installRootPack === undefined ? false : _ref8$installRootPack,
        _ref8$installPeerDepe = _ref8.installPeerDependencies,
        installPeerDependencies = _ref8$installPeerDepe === undefined ? false : _ref8$installPeerDepe,
        _ref8$verbose = _ref8.verbose,
        verbose = _ref8$verbose === undefined ? false : _ref8$verbose;
    var results, rootDirResults, installInDir, promisesResults;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!(useWorkspaces && packageManager === 'yarn')) {
              _context4.next = 3;
              break;
            }

            _context4.next = 3;
            return _installInOneDirectoryWithPeerOption({
              modules,
              packageManager,
              packageManagerArgs,
              packageManagerProcessOptions,
              dir: rootDir,
              installPeerDependencies,
              verbose
            });

          case 3:
            results = [];

            if (!installRootPackageJson) {
              _context4.next = 9;
              break;
            }

            _context4.next = 7;
            return _installInOneDirectoryWithPeerOption({
              modules,
              packageManager,
              packageManagerArgs,
              packageManagerProcessOptions,
              dir: rootDir,
              installPeerDependencies,
              verbose
            });

          case 7:
            rootDirResults = _context4.sent;

            if (Array.isArray(rootDirResults)) {
              results.concat(rootDirResults);
            } else {
              results.push(rootDirResults);
            }

          case 9:
            installInDir = function installInDir(dir) {
              return _installInOneDirectoryWithPeerOption({
                modules,
                packageManager,
                packageManagerArgs,
                packageManagerProcessOptions,
                dir,
                installPeerDependencies,
                verbose
              });
            };

            // run npm install for each one of the directories serially, not in parallel. Don’t use Promise.all() here.
            // running them in parallel result in race condition and random NPM errors. (see https://github.com/teambit/bit/issues/1617)


            _context4.next = 12;
            return (0, (_pMapSeries || _load_pMapSeries()).default)(dirs, installInDir);

          case 12:
            promisesResults = _context4.sent;
            return _context4.abrupt('return', results.concat((_ramda || _load_ramda()).default.flatten(promisesResults)));

          case 14:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function installAction(_x5) {
    return _ref7.apply(this, arguments);
  };
}();

var printResults = function printResults(_ref9) {
  var stdout = _ref9.stdout,
      stderr = _ref9.stderr;

  console.log((_chalk || _load_chalk()).default.yellow(stdout)); // eslint-disable-line
  console.log((_chalk || _load_chalk()).default.yellow(stderr)); // eslint-disable-line
};

exports.default = {
  install: installAction,
  printResults,
  isSupportedInstallationOfSubDirFromRoot
};