'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

/**
 * schema for analytics.
 */
exports.default = {
  properties: {
    analyticsResponse: {
      required: true,
      default: 'yes',
      description: `help us prioritize new features and bug fixes by enabling us to collect anonymous statistics about your usage. sharing anonymous usage information is completely voluntary and helps us improve Bit and build a better product.
for more information see analytics documentation - https://${(_constants || _load_constants()).BASE_DOCS_DOMAIN}/docs/conf-analytics.html
would you like to help Bit with anonymous usage analytics? [yes(y)/no(n)]`,
      message: 'please choose yes or no.',
      type: 'string',
      conform(value) {
        return value.toLowerCase() === 'y' || value.toLowerCase() === 'n' || value.toLowerCase() === 'yes' || value.toLowerCase() === 'no';
      }
    }
  }
};