'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _zlib;

function _load_zlib() {
  return _zlib = require('zlib');
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _ref4;

function _load_ref() {
  return _ref4 = _interopRequireDefault(require('./ref'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// import logger from '../../logger/logger';

function parse(buffer, types) {
  var firstNullByteLocation = buffer.indexOf((_constants || _load_constants()).NULL_BYTE);
  var headers = buffer.slice(0, firstNullByteLocation).toString();
  var contents = buffer.slice(firstNullByteLocation + 1, buffer.length);

  var _headers$split = headers.split((_constants || _load_constants()).SPACE_DELIMITER),
      _headers$split2 = _slicedToArray(_headers$split, 1),
      type = _headers$split2[0];

  return types[type].parse(contents);
}

var BitObject = function () {
  function BitObject() {
    _classCallCheck(this, BitObject);

    this.validateBeforePersist = true;
  }

  _createClass(BitObject, [{
    key: 'id',
    // validate the object before persisting
    value: function id() {
      throw new Error('id() was not implemented...');
    }

    // eslint-disable-next-line no-unused-vars

  }, {
    key: 'toBuffer',
    value: function toBuffer(pretty) {
      throw new Error('toBuffer() was not implemented...');
    }

    // eslint-disable-next-line no-unused-vars

  }, {
    key: 'refs',
    value: function refs() {
      return [];
    }
  }, {
    key: 'getHeader',
    value: function getHeader(buffer) {
      return `${this.constructor.name} ${this.hash().toString()} ${buffer.toString().length}${(_constants || _load_constants()).NULL_BYTE}`;
    }
  }, {
    key: 'collectRefs',
    value: function () {
      var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(repo) {
        var addRefs = function () {
          var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(object) {
            var refs, objs;
            return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    refs = object.refs();
                    _context.next = 3;
                    return Promise.all(refs.map(function (ref) {
                      return ref.load(repo, true);
                    }));

                  case 3:
                    objs = _context.sent;

                    refsCollection.push.apply(refsCollection, _toConsumableArray(refs));
                    // $FlowFixMe
                    _context.next = 7;
                    return Promise.all(objs.map(function (obj) {
                      return addRefs(obj);
                    }));

                  case 7:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          return function addRefs(_x2) {
            return _ref2.apply(this, arguments);
          };
        }();

        var refsCollection;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                refsCollection = [];
                _context2.next = 3;
                return addRefs(this);

              case 3:
                return _context2.abrupt('return', refsCollection);

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function collectRefs(_x) {
        return _ref.apply(this, arguments);
      }

      return collectRefs;
    }()
  }, {
    key: 'collectRaw',
    value: function () {
      var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(repo) {
        var refs;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.collectRefs(repo);

              case 2:
                refs = _context3.sent;
                return _context3.abrupt('return', Promise.all(refs.map(function (ref) {
                  return ref.loadRaw(repo);
                })));

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function collectRaw(_x3) {
        return _ref3.apply(this, arguments);
      }

      return collectRaw;
    }()
  }, {
    key: 'asRaw',
    value: function asRaw(repo) {
      return repo.loadRaw(this.hash());
    }
  }, {
    key: 'collect',
    value: function collect(repo) {
      var objects = [];

      function addRefs(object) {
        var objs = object.refs().map(function (ref) {
          return ref.loadSync(repo);
        });

        objects.concat(objs);
        // $FlowFixMe
        objs.forEach(function (obj) {
          return addRefs(obj);
        });
      }

      addRefs(this);
      return objects;
    }

    /**
     * indexing method
     */

  }, {
    key: 'hash',
    value: function hash() {
      // console.log(`sha ${sha1(this.id())}, id ${this.id()}`); // uncomment when debugging hash issues
      return new (_ref4 || _load_ref()).default(BitObject.makeHash(this.id()));
    }
  }, {
    key: 'compress',
    value: function compress() {
      return (0, (_utils || _load_utils()).deflate)(this.serialize());
    }
  }, {
    key: 'serialize',
    value: function serialize() {
      var buffer = this.toBuffer();
      return Buffer.concat([Buffer.from(this.getHeader(buffer)), buffer]);
    }

    /**
     * see `this.parseSync` for the sync version
     */

  }], [{
    key: 'parse',
    value: function parse(data) {
      throw new Error('parse() was not implemented...');
    }
  }, {
    key: 'parseObject',
    value: function parseObject(fileContents, types) {
      return (0, (_utils || _load_utils()).inflate)(fileContents).then(function (buffer) {
        return parse(buffer, types);
      });
    }

    /**
     * prefer using `this.parseObject()`, unless it must be sync.
     */

  }, {
    key: 'parseSync',
    value: function parseSync(fileContents, types) {
      var buffer = (0, (_zlib || _load_zlib()).inflateSync)(fileContents);
      return parse(buffer, types);
    }
  }, {
    key: 'makeHash',
    value: function makeHash(str) {
      return (0, (_utils || _load_utils()).sha1)(str);
    }
  }]);

  return BitObject;
}();

exports.default = BitObject;