/** @flow */
import firstline from 'firstline';
import { AUTO_GENERATED_STAMP } from '../constants';
import type { PathOsBased } from './path';

/**
 * check if file was auto generated by bit
 *
 * @param {PathOsBased} filePath - consumer path
 * @returns {boolean}
 */
export default (async function isFileAutoGenerated(filePath: PathOsBased): Promise<boolean> {
  const line = await firstline(filePath);
  return line.includes(AUTO_GENERATED_STAMP);
});
